//<![CDATA[
//AUTHOR:JULLYCAT(ZHANGYANJUN)

Namespace.register("Hc.widget.cookie");
Namespace.register("Hc.widget.movebox");
Namespace.register("Hc.util.setDiv");
Namespace.register("Hc.util.move");
Namespace.register("Hc.util.showDiv");
Namespace.register("Hc.util.hotClass");
Namespace.register("Hc.widget.hotword");
/**
 *应用类方法定义
 */
(function(){
	Hc.widget.cookie = {
		/**
		 * 新增或者修改cookie.
		 * @param {Object} name cookie名.
		 * @param {Object} value cookie值.
		 * @param {Object} time 有效时间单位为毫秒.
		 */
		newAndModif:function(name,value,time){
			if(time!=null&&this.time!=''){
				document.cookie = name+"="+value+"; expires="+this.createTime(time)+";";
			}else{
				document.cookie = name+"="+value+"; expires=Fri, 31 Dec 2100 23:59:59 GMT;";
			}
		},
		/**
		 * 创建cookie的有效时间.
		 * @param {Object} time
		 */
		createTime:function(time){
			var nowTime = new Date();
			time = parseInt(time)*24*60*60*1000 + parseInt(nowTime.getTime());
			var needTime = new Date(time);
			return needTime.toGMTString();
		},
		getValue:function(name){
			if(document.cookie != null){
				var cookieStrArr = document.cookie.split("; ");
				for(var i=0;i<cookieStrArr.length;i++){
					if(cookieStrArr[i].split("=")[0]==name){
						return cookieStrArr[i].split("=")[1];
					}
				}
			}else{
				return null;
			}
		}
	}
})();

/*
 *
 *
 */
 (function(){
	
	Hc.util.hotClass = {
		/*@method initAttention(),初始化热词展现区域及a对象的事件
		 *@param (cookie的前缀名,需要获取热词的父级id,热词显示区父级id,热词显示区的id,需要获取热词的上级tagName,显示热词的最大个数)
		 */
		 concat : function(arg1,arg2){
			var arg = new Array();
			var len1 = arg1.length;
			var len2 = arg2.length;
			for(var i=0;i<(len1+len2);i++){
				if(i<len1) arg[i] =arg1[i];
				else arg[i] = arg2[i-arg1.length];
			}
			arg1 = arg
			return arg1;
		},
		initAttention:function(cookiename,mainbox,disbox,conbox,tagName,max){
			var curObj = this;
			var parCodes;
			var childCodes = new Array;
			var temparr1=new Array,temparr2 = new Array;
			var hotwords = new Array();
			if(Hc.widget.cookie.getValue(cookiename) != null){
				var hotwords = curObj.getCookievalue(cookiename);
				curObj.getAttention(hotwords,conbox);
			}else{
					$(disbox).style.display = "none";
			}
			parCodes = $(mainbox).getElementsByTagName(tagName);
			for(var i=0;i<parCodes.length;i++){
				temparr = parCodes[i].getElementsByTagName("A");
				childCodes = this.concat(childCodes,temparr);
			}
			for(var j=0;j<childCodes.length;j++){
				childCodes[j].n = childCodes[j].childNodes[0].nodeValue;
				childCodes[j].u = childCodes[j].href;
				childCodes[j].onclick = function(){
					var curhotwords = new Array();
					curhotwords = curObj.getCookievalue(cookiename);
					curObj.setAttention(cookiename,curhotwords,this.u,this.n,max);
				}
			}
			
		},
		/*@method getCookievalue(),获取cookie值的后缀并返回Hc.widget.hotword对象的数组
		 *@param (cookie的前缀名)
		 */
		getCookievalue:function(cookiename){
			var word,hotword;
			var hotwords = new Array();
			if(Hc.widget.cookie.getValue(cookiename)!=null){
				var cookieValue = unescape(Hc.widget.cookie.getValue(cookiename));
				var wordarr = cookieValue.split("&");
				for(var i=0;i<wordarr.length;i++){
					word = wordarr[i].split("|");
					hotword = new Hc.widget.hotword(word[0],word[1]);
					hotwords.push(hotword);
				}
			}
			return hotwords;
		},
		/*@method setAttenttion(),获取最新热词
		 *@param (cookie的前缀名,最新热词数组,当前事件触发的对象,热词最大个数)
		 */
		setAttention:function(cookiename,arg,aurl,aword,max){
			var hotwords = new Array;
			var hotword = new Hc.widget.hotword(aword,aurl);
			var cookiestr = "";
			var flag = true;
			for(var i=0;i<arg.length;i++){
				hotwords[i] = arg[i];
			}
			if ((hotwords.length<max) && (hotwords.length!=0))
			{
				for(var j=0;j<hotwords.length;j++){
					if((hotwords[j].name == hotword.name) && (hotwords[j].url == hotword.url)){
//						flag=false;
						hotwords.splice(j,1);
					}
				}
//				if(flag) 
					hotwords.unshift(hotword);
			}else{
				hotwords.push(hotword);
				if(hotwords.length==max){
					hotwords.shift();
				}
			}
			for(var n=0;n<hotwords.length;n++){
				cookiestr = cookiestr + hotwords[n].name + "|" + hotwords[n].url +"&"
			}
			cookiestr = escape(cookiestr.substring(0,cookiestr.length-1));
			Hc.widget.cookie.newAndModif(cookiename,cookiestr);
		},
		/*@method getAttention(),
		 *@param (最新热词数组,热词显示区域id)
		 */
		getAttention:function(arg,conbox){
			var wordstr = "";
			for(var j=0;j<arg.length;j++){
				wordstr = wordstr + "<a href=\"" + arg[j].url + "\">" + arg[j].name + "</a> | ";
				if (((j+1)%3 == 0) || (j==arg.length-1))
				{
					wordstr = wordstr.substring(0,wordstr.length-3);
					wordstr = wordstr + "<br />";
				}
			}
			$(conbox).innerHTML = wordstr;
			
		}
	}
 })();

/*
 *重构DIV位置的静态类
 *@class setDiv
 */
(function(){
	var initheight,totalheight;
	Hc.util.setDiv = {
		/**
		 *初始化弹性显示DOM对象
		 *@method init
		 *@param (el,con,nums,overclassname,outclassname,speed,maxheight) tab前缀，显示内容前缀，tab个数，覆盖tab样式，离开tab样式，弹开速度，显示内容框高度
		 */
		init:function(el,con,nums,overclassname,outclassname,speed,maxheight){
			var arg = new Array();
			for(i=0;i<arguments.length;i++){
				arg[i] = arguments[i];
			}
			for(j=1;j<=parseInt(arg[2]);j++){
				tagBox = $(arg[0] + j);
				hidBox = $(arg[1] + j);
				tagBox.m = j;
				hidBox.m = j;
				tagBox.onmouseover=function(){Hc.util.showDiv.slideshow(arg,this.m);};
				tagBox.onmouseout=function(){Hc.util.showDiv.slideshow(arg,this.m);};
				hidBox.onmouseover=function(){Hc.util.showDiv.slideshow(arg,this.m);};
//				hidBox.onmouseout=function(){Hc.util.showDiv.slideshow(arg,this.m);};
			}
			Hc.util.showDiv.slideshow(arg,1);
		},
		/**
		 *构建移动DOM对象
		 *@method build
		 *@param (el,className,targetName) 父层对象，及移动对象使用的样式，移动对象的tagName
		 */
		build:function(el,className,targetName,cookiename,mspace){
			totalheight = 0;
			var mb_arr = new Array();
			var childtag = el.getElementsByTagName(targetName);
			for(i=0;i<childtag.length;i++){
				if(childtag[i].className==className){
					with(childtag[i].style){
						position = "absolute";
						top = totalheight + "px";
					}
					if(mspace!=null && mspace!="") totalheight = totalheight + childtag[i].scrollHeight + mspace;
					else totalheight = totalheight + childtag[i].scrollHeight;
					mb_arr[mb_arr.length] = childtag[i].id;
				}
			}
			el.style.height = totalheight + "px";
			Hc.util.move.init(el,mb_arr,cookiename);
		},
		/**
		 *获取cookie重置移动DOM对象
		 *@method rebuild
		 *@param (movebox,cookieValue) 父层对象，cookie截取后的字符
		 */
		rebuild:function(movebox,cookieValue,cookiename,mspace){
			totalheight = 0;
			var mb_arr = cookieValue.split("&");
			for(var i=0;i<mb_arr.length;i++){
				$(mb_arr[i]).style.position = "absolute";
				$(mb_arr[i]).style.top = totalheight + "px";
				if(mspace!=null && mspace!="") totalheight = totalheight + $(mb_arr[i]).scrollHeight + mspace;
				else totalheight = totalheight + $(mb_arr[i]).scrollHeight;
			}
			movebox.style.height = totalheight + "px";
			Hc.util.move.init(movebox,mb_arr,cookiename);
		},

		/**
		 *tab效果DOM对象初始化
		 *@method tabDivinit
		 *@param (nums,tab,con,curClassName,speed,oEvent) tab个数，tab前缀，显示内容前缀，tab当前时的样式，切换速度，设置控制切换的事件
		 */
		tabDivinit:function(nums,tab,con,curClassName,speed,oEvent){
			var t = oEvent;
			var arg = new Array;
			for(i=0;i<arguments.length;i++){
				arg[i] = arguments[i];
			}
			for(var j=0;j<arg[0];j++){
				var curtab = $(arg[1] + j);
				curtab.n = j;
				switch(t){
					case 'click':
						curtab.onclick = function(){Hc.util.showDiv.show(arg,this.n);};
						break;
					default:
						curtab.onmouseover = function(){Hc.util.showDiv.show(arg,this.n);};
						break;
				}
			}
			return arg;
		}
	};
})();

/**
 *显示隐藏类
 *@class showDiv
 */
(function(){
	var pos;
	var showpos;
	Hc.util.showDiv = {
		/**
		 *tab切换控制，切屏事件可设置
		 *@param arg是数组类,id为当前出发对象的编号
		 */
		show:function(arg,id){
			var curtab,curobj;
			curobj = this;
			var useArg = new Array;
			for(j=0;j<arg.length;j++){
				useArg[j] = arg[j];
			}
			for(var i=0;i<useArg[0];i++){
				curtab = $(useArg[1] +i);
				if(i==id){ 
					curtab.className = useArg[3];
					$(useArg[2]+i).style.display = "block";
				}else{
					curtab.className = '';
					$(useArg[2]+i).style.display = "none";
				}
			}	
		},

		/**
		 *tab自动切换控制，切屏事件自动设置
		 *@param arg是数组类
		 */
		autoshow:function(arg){
			var time1,curobj,curtab,curnum,bpos;
			curnum = 1;
			curobj = this;
			bpos = 0;
			var useArg = new Array;
			for(j=0;j<arg.length;j++){
				useArg[j] = arg[j];
			}
			this.show(useArg,0);
			function ctrl(){
				time1 = setInterval(function(){
					if(curnum>=useArg[0]) curnum=0;
					bpos = curnum;
					curobj.show(useArg,curnum);
					curnum++;
				},useArg[4])
			}
			ctrl();
			for(var i=0;i<useArg[0];i++){
				curtab = $(useArg[1] +i);
				switch(useArg[5]){
					case 'click':
						curtab.onclick = function(){curobj.show(useArg,this.n);};
						curtab.onmouseover = function(){clearInterval(time1);bpos=this.n;}
						break;
					default:
						curtab.onmouseover = function(){clearInterval(time1);curobj.show(useArg,this.n);bpos=this.n;};
						break;
				}
				$(useArg[2] +i).onmouseover = function(){clearInterval(time1);bpos++;}
				$(useArg[2] +i).onmouseout = function(){
//					bpos++;
//					if(bpos==useArg[0]) bpos=0;
//					curobj.show(useArg,bpos);
					curnum = bpos;
					ctrl();
				}
				curtab.onmouseout = function(){
//					if(bpos==useArg[0]) bpos=0;
//					curobj.show(useArg,bpos);
					curnum = bpos;
					ctrl();
				}
			}
		},
		/**
		 *由onmouseover和onmouseout事件触发，弹性显示
		 *@param arg是数组类，id是tab的后缀数字
		 */
		slideshow:function(arg,id){
			var curobj = new Array();
			for(j=0;j<arg.length;j++){
				curobj[j] = arg[j];
			}
			var tagBox,hidBox;
			var ctrl = 0;
			if((id!=pos)||(pos==null)){
				for(i=1;i<=parseInt(curobj[2]);i++){
					tagBox = $(curobj[0] + i);
					hidBox = $(curobj[1] + i);
					if(i==id){
						pos=id;
						tagBox.className = curobj[3];
						hidBox.style.display = "block";
	/*设置弹性效果
//						hidBox.style.overflow = "hidden";
//						hidBox.style.height = "0px";
//						var time1 = setInterval(function(){
//							var ids = id;
//							ctrl +=	curobj[5];
//							if(ctrl>curobj[6]) {
//								clearInterval(time1);
//								ctrl = curobj[6];
//							}
//							$(curobj[1] + ids).style.height = ctrl  + "px";
//						},30);
	*/
						hidBox.style.height = curobj[6] + "px";
					}else{
							hidBox.style.height = "0px";
							tagBox.className = curobj[4];
							hidBox.style.display = "none";
					}
				}
			}
		}
		
	}
})();

/**
 *移动类
 *@class move
 */
(function(){
	var movebox = null;
	var moveboxs = new Array();
	var oStart,oEnd,oStartY,oEndY;
	var speed = 10;
	var mflag = true;
	Hc.util.move = {
		/**
		 *增加movebox对象
		 *@param id 移动层的父层
		 *@param 移动层id
		 */
		init:function(id,mb_arr,cookiename){
			
			var movebox = new Hc.widget.movebox(id);
			for(var i=0;i<mb_arr.length;i++){
				movebox.list.push($(mb_arr[i]));
			}
			movebox.cookieid = cookiename;
			moveboxs.push(movebox);
		},

		/**
		 * 向上移动当前对象在整个对象中的位置，并交换互相的位置.
		 * @method moveUp 
		 * @param {Object} m_b movebox的DOM对象.
		 * @param {Object} now 当前准备移动的DOM对象,包含在m_b里面.
		 */
		moveUp:function(m_b,now){
			if(mflag){
			oStart=null;
			oEnd=null;
			oStartY=null;
			oEndY=null;
			var changepoint = new Array();
			movebox = this.isHave(m_b);
			if(this.getUp(now)!=null){
				changepoint = this.getUp(now);
				oStart = changepoint[0];
				oEnd = changepoint[1];
				oStartY = parseInt(oEnd.style.top);
				oEndY = parseInt(oStart.style.top);
				oStart.style.zIndex = "0";
				oEnd.style.zIndex = "360";
				oStart.style.filter="alpha(opacity=10)";
				this.startmoving();
				this.endmoving();
				oStart.style.filter="alpha(opacity=100)";
			}
			this.change(oEnd,oStart);
			Hc.widget.cookie.newAndModif(movebox.cookieid,this.toString(),30);
			}
			
		},
		/**
		 *向下移动当前对象在整个对象中的位置，并交换互相的位置.
		 *@method moveDown 
		 */
		moveDown:function(m_b,now){
		if(mflag){
			oStart=null;
			oEnd=null;
			oStartY=null;
			oEndY=null;
			var changepoint = new Array();
			movebox = this.isHave(m_b);
			if(this.getDown(now)!=null){
				changepoint = this.getDown(now);
				oStart = changepoint[0];
				oEnd = changepoint[1];
				oStartY = parseInt(oEnd.style.top);
				oEndY = parseInt(oStart.style.top);
				oStart.style.zIndex = "360";
				oEnd.style.zIndex = "0";
				oEnd.style.filter="alpha(opacity=10)";
				this.startmoving();
				this.endmoving();
				oEnd.style.filter="alpha(opacity=100)";
			}
			this.change(oEnd,oStart);
			Hc.widget.cookie.newAndModif(movebox.cookieid,this.toString(),30);
		}
			
		},
		/**
		 *上一层的移动定位
		 */
		startmoving:function(){
			var con = this;
			yStart = parseInt(oStart.style.top);
			yEnd = oStartY+(oEnd.scrollHeight-oStart.scrollHeight);
			if(yStart<yEnd){
				this.moveY(oStart,1,speed,yEnd);
				setTimeout(function(){con.startmoving()},1);
				mflag = false;
			}
			if(yStart>yEnd){
				this.moveY(oStart,2,speed,yEnd);
				setTimeout(function(){con.startmoving()},1);
				mflag = false;
			}
			if(yStart==yEnd){
				mflag = true;
			}
		},
		/**
		 *下一层移动定位
		 */
		endmoving:function(){
			yStart = parseInt(oEnd.style.top);
			yEnd = parseInt(oEndY);
			var con = this;
			if(yStart<yEnd){
				this.moveY(oEnd,1,speed,yEnd);
				setTimeout(function(){con.endmoving()},1);
				mflag = false;
			}
			if(yStart>yEnd){
				this.moveY(oEnd,2,speed,yEnd);
				setTimeout(function(){con.endmoving()},1);
				mflag = false;
			}
			if(yStart==yEnd){
				mflag = true;
			}
		},
		/**
		 *调整浮动层obj的top值
		 *@method moveY
		 */
		moveY:function(obj,ySpeenType,speed,yEnd){
			if(ySpeenType==1){
				if((parseInt(obj.style.top)+speed)>yEnd){
					obj.style.top = yEnd+"px";
				}else{
					obj.style.top = parseInt(obj.style.top)+speed+"px";
				}
			}
			if(ySpeenType==2){
				if((parseInt(obj.style.top)-speed)<yEnd){
					obj.style.top = yEnd+"px";
				}else{
					obj.style.top = parseInt(obj.style.top)-speed+"px";
				}
			}
		},
		/**
		 *获取移动对象在movebox对象list中的位置
		 *@method getIndex 
		 *@param 移动对象
		 */
		getIndex:function(moveObj){
			for(var i=0;i<movebox.list.length;i++){
				if(movebox.list[i]==moveObj){
					return i;
				}
			}
			return -1;
		},
		/**
		 *获取moveboxs中movebox对象
		 *@param m_b是移动层的父层
		 */
		isHave:function(m_b){
			for(var i=0;i<moveboxs.length;i++){
				if(moveboxs[i].name==$(m_b.id)){
					return moveboxs[i];
				}
			}
		},
		/**
		 * 向上获取当前对象的临近的对象.
		 * @method getUp 
		 * @param {Object} now 当前对象.
		 */
		getUp:function(now){
			var arrm = new Array();
			for(var i=0;i<movebox.list.length;i++){
				if(movebox.list[i]==now){
					if(i>0){
						arrm[0] = movebox.list[i-1];
						arrm[1] = movebox.list[i];
						return arrm;
					}else{
						return null;
					}
				}
			}
		},
		/**
		 * 向下获取当前对象的临近的对象.
		 * @method getDown 
		 * @param {Object} now 当前对象.
		 */
		getDown:function(now){
			var arrm = new Array();
			for(var i=0;i<movebox.list.length;i++){
				if(movebox.list[i]==now){
					if(i<movebox.list.length-1){
						arrm[0] = movebox.list[i];
						arrm[1] = movebox.list[i+1];
						return arrm;
					}else{
						return null;
					}
				}
			}
		},
		/**
		 *改变移动对象在movebox.list中的位置
		 *@method change
		 *@param (start,end)移动的两个对象
		 */
		change:function(start,end){
			var s_index = this.getIndex(start);
			var e_index = this.getIndex(end);
			if(s_index!=-1&&e_index!=-1){
				movebox.list[s_index] = end;
				movebox.list[e_index] = start;
				movebox.version++;
			}
		},
		/**
		 *将movebox对象中的list数组值用&连接返回字符串
		 *@method toString
		 */
		toString:function(){
			var tempStr = "";
			for(var i=0;i<movebox.list.length;i++){
				tempStr = tempStr + movebox.list[i].id + "&";
			}
			tempStr = tempStr.substring(0,tempStr.length-1);
			return tempStr;
		}
	};
})();




/**
 * 移动的组合类.
 * @class movebox
 * @param {Object} name 整个movebox的ID名称.
 */
Hc.widget.movebox = function(name){
	this.name = name;
	this.list = new Array();
	this.size = 0;
	this.version = 0;
	this.obj = null;
	this.cookieid = null;
}

Hc.widget.hotword = function(name,url){
	this.name = name;
	this.url = url;
}
//]]>

